<?php

/**
 * det_liq_gen_deb actions.
 *
 * @package    canon
 * @subpackage det_liq_gen_deb
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class det_liq_gen_debActions extends sfQuery {

    /**
     * Metodo list de accesos
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {

        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Formato de fecha
         */
        //Sql
        $sql = <<<EOD
ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD" 
EOD;
        //Ejecutar SQL
        CN_TABLE::executeSQL($sql);

        /*
         * Manejo de errores
         */
        try {

            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 300;
            }

            /*
             * variables de filtro
             */
            $id_titulo = "";
            if (isset($request['id_titulo'])) {
                $id_titulo = $request['id_titulo'];
            }

            $id_etapa = "";
            if (isset($request['id_etapa'])) {
                $id_etapa = $request['id_etapa'];
            }



            $query = "
        select * from (

  select 
  tab0.valor, tab0.id_titulo, tab2.id_anual_etapa, tab2.fecha_inicio, 
  tab2.fecha_fin, tab2.anualidad, tab3.abreviacion, tab3.nombre as nombre_etapa, tab3.id_etapa,
  tab4.cod_titulo, nvl(mg.es_gobernacion,0) as es_gobernacion, 
  aed.id_debito as id_debito_old
  from ca_det_liq_canon tab0 
  join ca_anual_etapa tab2 on tab0.id_anual_etapa=tab2.id_anual_etapa
  join ca_etapa tab3 on tab0.id_etapa=tab3.id_etapa
  join rmn_titulo tab4 on tab0.id_titulo=tab4.id_titulo
  left join CA_TITULO_MARCA_GOB mg on tab0.id_titulo=mg.id_titulo
  left join ca_anual_etapa_deb aed on tab2.ID_ANUAL_ETAPA=aed.id_anual_etapa
  where tab0.id_titulo=$id_titulo and tab3.id_etapa=$id_etapa and tab0.anulado=0 and tab0.aprobado=1

)table1 join (

  select             
  titper.ID_PERSONA,
  titper.NOMBRE,
  titper.PRIMER_APELLIDO,
  titper.SEGUNDO_APELLIDO,
  titper.TELEFONO,
  titper.CELULAR,
  titper.CORREO,
  titper.CORREO_ALT,
  titper.RAZ_SOC,
  titper.NUM_DOC,
  titper.id_titulo,
  titper.id_titulo_persona,
  titper.id_titular
  from rmn_titulo_persona_mv titper join (
    
    SELECT 
    titper.*,
    ROW_NUMBER() OVER (
    PARTITION BY titper.id_titulo
    ORDER BY titper.id_titulo_persona ASC
    ) AS rn
    from rmn_titulo_persona_mv titper
    --mod by harold 22/06/2015 unico rol valido es titular id_rol=26 HARD CODED
    where titper.actual = 1 and titper.id_rol_titulo=26
    
  )tab on titper.id_titulo_persona = tab.id_titulo_persona 
  and titper.id_titular = tab.id_titular and tab.rn = 1
  order by titper.id_titulo_persona 
  
)table2 on table1.id_titulo=table2.id_titulo";

            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from(
 
   $query
 
)tabla
EOD;

            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];

            //validar si hay registros
            if ($total_record_count > 0) {

                /*
                 * Obtiene los accesos para un perfil
                 */
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
      
   $query
                        
order by
anualidad    
            
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;

                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);

                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowEnd;
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[DET_LIQ_GEN_DEB] Consulta exitosa.");
            } else {

                $mensaje = "[DET_LIQ_GEN_DEB] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[DET_LIQ_GEN_DEB] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    // Validate
    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Add
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateAdd(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Update
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateUpdate(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Ejecuta una validación previa a la ejecución de una operación tipo Remove
     *
     * @param sfWebRequest $request
     * @return array 
     */
    protected function validateRemove(sfWebRequest $request) {

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    /**
     * Acciones anteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function preprocessRequest($Action, sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    /**
     * Acciones posteriores a la original
     * 
     * return sfWebRequest Changed Request with additional parameters.
     * 
     * @param type $Action ( ADD, UPDATE, REMOVE )
     * @param sfWebRequest $request
     * @return \sfWebRequest 
     */
    protected function postprocessRequest($Action, sfWebRequest $request, $list_data_post) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

}
